/** BEGIN COPYRIGHT BLOCK
 * Copyright (C) 2001 Sun Microsystems, Inc. Used by permission.
 * Copyright (C) 2005 Red Hat, Inc.
 * All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation version 2 of the License.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * END COPYRIGHT BLOCK **/

package com.netscape.admin.dirserv;

import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import com.netscape.management.client.*;
import com.netscape.management.client.util.*;

/**
 * Status bar item for continuous progress feedback
 *
 * @author  kirwin
 * @version %I%, %G%
 * @date    4/8/98
 * @see     com.netscape.admin.dirserv
 */
public class StatusItemContinuousProgress extends StatusItemProgress
{
    private int _val = 0;
    private static int VALUE_INCREMENT = 9;
    private static int UPDATE_INTERVAL = 50;
    private static int INITIAL_DELAY = 0;
    private ProgressTracker _thread;
    boolean _running = false;

	public StatusItemContinuousProgress(String id) {
        super(id, 0);
        _thread = new ProgressTracker();
        _thread.start();
	}

    public void start() {
        if (!_running) {
            _running = true;
            _val = 100;
            increment();
            _thread.resume();
        }
    }

    public void stop() {
        if (_running) {
            _running = false;
            _val = 100;
            increment();
        }
    }

    private void increment() {
        try {
            Graphics g = getGraphics();
            if ((_val += VALUE_INCREMENT) > 99) {
                _val = 0;
                if (g != null) {
                    Rectangle r = getBounds();
                    g.clearRect(0, 0, r.width, r.height);
                }
            }
            setValue(_val);
            update(g);
        }
        catch (Exception e) {
        }
    }

    private class ProgressTracker extends Thread {

        public void run() {
            while (true) {
                while (_running) {
                    increment();
                    try {
                        sleep(UPDATE_INTERVAL);
                    } catch (InterruptedException e) {
                        Debug.println("sleep exception");
                    }
                }
                suspend();
            }
        }
    }
}
